; setjmp/longjmp for D10V.  The jmpbuf looks like this:
;
; Register		jmpbuf offset
; R1			0x00	
; R8			0x02
; R9			0x04
; R10			0x06
; R11			0x08
; R13 (return address)	0x0A
; R14			0x0C
; R15 (SP)		0x0E

	.text
	.globl	setjmp
setjmp:
; Address of jmpbuf is passed in R2.  Save the appropriate registers.
	st	r1, @r2+		; Save R1
	st2w	r8, @r2+		; Save R8 and R9
	st2w	r10, @r2+		; Save R10 and R11
	st	r13, @r2+		; Save R13
	st2w	r14, @r2+		; Save R14 and R15

; Return 0 to caller
	ldi	r2, 0
	jmp	r13

	.globl	longjmp
longjmp:
; Address of jmpbuf is in R2.  Restore the registers.
	ld	r1, @r2+		; Restore R1
	ld2w	r8, @r2+		; Restore R8 and R9
	ld2w	r10, @r2+		; Restore R10 and R11
	ld	r13, @r2+		; Restore R13
	ld2w	r14, @r2+		; Restore R14 and R15

; Value to return to caller is in R3.  If caller attemped to return 0,
; return 1 instead.

	mv	r2, r3
	cmpeqi	r2, 0
	exef0t || ldi r2,1
	jmp	r13
