	.text
	.global	_start

_start:

; R0 always contains memory base address (0)

	ldi	r0,0

; Set the stack pointer.

	ldi	sp, _stack

; Clear the BSS.  Do it in two parts for efficiency: longwords first
; for most of it, then the remaining 0 to 3 bytes.

	ldi	r2, __bss_start	; R2 = start of BSS
	ldi	r3, _end	; R3 = end of BSS + 1
	sub	r3, r2		; R3 = BSS size in bytes
	mv	r4, r3
	srli	r4, 2		; R4 = BSS size in longwords (rounded down)
	mv	r1, r0		; clear R1 for longword store
loop1:
	cmpeqi	r4, 0		; more longords to zero out?
	brf0t.s	endloop1	; nope
	st2w	r0, @r2+	; yep, zero out another longword
	subi	r4, 1		; decrement count
	bra.l	loop1		; go do some more

endloop1:
	and3	r4, r3, 3	; get no. of remaining BSS bytes to clear
loop2:
	cmpeqi	r4, 0		; more bytes to zero out?
	brf0t.s	endloop2	; nope
	stb	r0, @r2		; yep, zero out another byte
	addi	r2, 1		; bump address
	subi	r4, 1		; decrement count
	bra.s	loop2		; go do some more
endloop2:
	
; Call main, then stop simulator

	bl	main
	bl	exit
	stop

	.section .stack
_stack:	.long	1
