#include "sys/syscall.h"

#define SYSCALL(name) \
	.global name	; \
name:			; \
	ldi	r6, SYS ## name ; \
	bra	__trap0

	.text
	.global	__trap0
	.type	__trap0,@function
__trap0:
	trap	15		/* trap 15 returns result in r2, error code in r3 */
	cmpeqi	r4,0		/* is error code zero? */
	brf0t	ret		/* yes, skip setting errno */
#if __INT__==32
	st	r4,@(errno+2,r0) /* no, set errno */
	srai	r4,15
	st	r4,@(errno,r0)
#else
	st	r4,@(errno,r0)	/* no, set errno */
#endif

ret:
	jmp	r13		/* return to caller */
	.size	__trap0,.-__trap0

#if __INT__==32
#define _read _read16
#define _lseek _lseek16
#define _write _write16
#define _close _close16
#define _open _open16
#define _creat _creat16
#define _exit _exit16
#define _stat _stat16
#define _chmod _chmod16
#define _chown _chown16
#define _fork _fork16
#define _wait _wait16
#define _execve _execve16
#define _execv _execv16
#define _pipe _pipe16
#define _kill _kill16
#define _getpid _getpid16
#endif

/* Until the assembler allows semicolon as a statement separator, */
/* we cannot use the SYSCALL macro.  So expand it manually for now. */

/* #SYSCALL(_read) */
/* #SYSCALL(_lseek) */
/* #SYSCALL(_write) */
/* #SYSCALL(_close) */
/* #SYSCALL(_open) */
/* #SYSCALL(_creat) */
/* #SYSCALL(_exit) */
/* #SYSCALL(_stat) */
/* #SYSCALL(_chmod) */
/* #SYSCALL(_chown) */
/* #SYSCALL(_fork) */
/* #SYSCALL(_wait) */
/* #SYSCALL(_execve) */
/* #SYSCALL(_execv) */
/* #SYSCALL(_pipe) */
/* #SYSCALL(_getpid) */
/* #SYSCALL(_kill) */

	.global	_read
	.type	_read,@function
_read:
	ldi	r6, SYS_read
	bra	__trap0
	.size	_read,.-_read

	.global	_lseek
	.type	_lseek,@function
_lseek:
	ldi	r6, SYS_lseek
	bra	__trap0
	.size	_lseek,.-_lseek

	.global	_write
	.type	_write,@function
_write:
	ldi	r6, SYS_write
	bra	__trap0
	.size	_write,.-_write

	.global	_close
	.type	_close,@function
_close:
	ldi	r6, SYS_close
	bra	__trap0
	.size	_close,.-_close

	.global	_open
	.type	_open,@function
_open:
	ldi	r6, SYS_open
	bra	__trap0
	.size	_open,.-_open

	.global	_creat
	.type	_creat,@function
_creat:
	ldi	r6, SYS_creat
	bra	__trap0
	.size	_creat,.-_creat

	.global	_exit
	.type	_exit,@function
_exit:
	ldi	r6, SYS_exit
	bra	__trap0
	.size	_exit,.-_exit

	.global	_stat
	.type	_stat,@function
_stat:
	ldi	r6, SYS_stat
	bra	__trap0
	.size	_stat,.-_stat

	.global	_chmod
	.type	_chmod,@function
_chmod:
	ldi	r6, SYS_chmod
	bra	__trap0
	.size	_chmod,.-_chmod

	.global	_chown
	.type	_chown,@function
_chown:
	ldi	r6, SYS_chown
	bra	__trap0
	.size	_chown,.-_chown

	.global	_fork
	.type	_fork,@function
_fork:
	ldi	r6, SYS_fork
	bra	__trap0
	.size	_fork,.-_fork

	.global	_wait
	.type	_wait,@function
_wait:
	ldi	r6, SYS_wait
	bra	__trap0
	.size	_wait,.-_wait

	.global	_execve
	.type	_execve,@function
_execve:
	ldi	r6, SYS_execve
	bra	__trap0
	.size	_execve,.-_execve

	.global	_execv
	.type	_execv,@function
_execv:
	ldi	r6, SYS_execv
	bra	__trap0
	.size	_execv,.-_execv

	.global	_pipe
	.type	_pipe,@function
_pipe:
	ldi	r6, SYS_pipe
	bra	__trap0
	.size	_pipe,.-_pipe

	.global	time
	.type	time,@function
time:
	ldi	r6, SYS_time
	bra	__trap0
	.size	time,.-time

	.global	_kill
	.type	_kill,@function
_kill:
	ldi	r6, SYS_kill
	bra	__trap0
	.size	_kill,.-_kill

	.global	_getpid
	.type	_getpid,@function
_getpid:
	ldi	r6, SYS_getpid
	bra	__trap0
	.size	_getpid,.-_getpid
